unit MuMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs, MuCpMth,
  StdCtrls, Grids, Outline, DirOutln, FileCtrl, ComCtrls, Buttons, ExtCtrls;

type
  TMuCopyMain = class(TForm)
    SourceDir: TDirectoryListBox;
    TargetDir: TDirectoryListBox;
    SourceDrive: TDriveComboBox;
    TargetDrive: TDriveComboBox;
    CStatus: TStatusBar;
    CPanel: TPanel;
    CCopy: TSpeedButton;
    SpeedButton1: TSpeedButton;
    procedure SourceDriveChange(Sender: TObject);
    procedure TargetDriveChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure CCopyClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure SourceDirMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TargetDirMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure SpeedButton1Click(Sender: TObject);
  end;

var
  MuCopyMain: TMuCopyMain;

implementation

{$R *.DFM}

procedure TMuCopyMain.SourceDriveChange(Sender: TObject);
begin
   try
   SourceDrive.Update;
   SourceDir.Drive := SourceDrive.Drive;
   except
   SourceDrive.Drive:=SourceDir.Drive;
   end;
   end;

procedure TMuCopyMain.TargetDriveChange(Sender: TObject);
begin
   try
   TargetDrive.Update;
   TargetDir.Drive := TargetDrive.Drive;
   except
   TargetDrive.Drive:=TargetDir.Drive;
   end;
   end;

procedure TMuCopyMain.FormCreate(Sender: TObject);
begin
   Resize;
   end;

procedure TMuCopyMain.CCopyClick(Sender: TObject);
var
   Dir1,Dir2:string;
begin
   SourceDir.Enabled:=False;
   TargetDir.Enabled:=False;
   Dir1:=SourceDir.Directory;
   Dir2:=TargetDir.Directory;
   SourceDir.OpenCurrent;
   TargetDir.OpenCurrent;
   TCopy.Create(SourceDir.Directory,TargetDir.Directory,SourceDir,TargetDir);
   SourceDir.Update;
   TargetDir.Update;
   SourceDir.Directory:=dir1;
   TargetDir.Directory:=dir2;
   SourceDir.Enabled:=True;
   TargetDir.Enabled:=True;
   end;

procedure TMuCopyMain.FormResize(Sender: TObject);
begin
   SourceDrive.Top:=CPanel.Height;
   TargetDrive.Top:=CPanel.Height;
   SourceDir.Top:=SourceDrive.Top+SourceDrive.Height;
   TargetDir.Top:=SourceDir.Top;
   SourceDir.Height:=MuCopyMain.ClientHeight-CPanel.Height-2*CStatus.Height;
   TargetDir.Height:=SourceDir.Height;
   SourceDir.Width:=MuCopyMain.ClientWidth div 2;
   TargetDir.Width:=SourceDir.Width;
   SourceDir.Left:=0;
   TargetDir.Left:=SourceDir.Width;
   SourceDrive.Width:=SourceDir.Width;
   TargetDrive.Width:=SourceDir.Width;
   SourceDrive.Left:=0;
   TargetDrive.Left:=SourceDir.Width;
   end;

procedure TMuCopyMain.SourceDirMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   APoint:Tpoint;
   TIndex: integer;
begin
   APoint.X:=X;
   APoint.Y:=Y;
   if Button=mbRight then begin
      TIndex:=SourceDir.ItemAtPos(APoint,True);
      if TIndex>=0 then SourceDir.Directory:=SourceDir.GetItemPath(TIndex);
      end;
   end;

procedure TMuCopyMain.TargetDirMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
var
   APoint:Tpoint;
   TIndex: integer;
begin
   APoint.X:=X;
   APoint.Y:=Y;
   if Button=mbRight then begin
      TIndex:=TargetDir.ItemAtPos(APoint,True);
      if TIndex>=0 then TargetDir.Directory:=TargetDir.GetItemPath(TIndex);
      end;
   end;

procedure TMuCopyMain.SpeedButton1Click(Sender: TObject);
begin
   MessageDlg('Multithread directory copy (c) Daniel Doubrovkine - 1996'+Chr(10)+Chr(13)+
              'email welcome: dblock@infomaniak.ch - Stolen Technologies Inc. - University of Geneva',mtInformation,[mbOk],0);
   end;

end.
